import { Component } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { AuthService } from '../../services/auth/auth.service';
import { Router } from '@angular/router';

@Component({
  selector: 'app-register',
  templateUrl: './register.component.html',
  styleUrls: ['./register.component.scss', '../auth.component.scss']
})
export class RegisterComponent {
  registerForm = new FormGroup({
    username: new FormControl(''),
    password: new FormControl(''),
    rePassword: new FormControl('')
  });

  constructor(private router: Router, private auth: AuthService) {
    this.registerForm.addValidators([Validators.required, Validators.minLength(3)]);
  }

  register() {
    if (this.registerForm.valid)
      this.auth.register(
        this.registerForm.get('username')?.value as String,
        this.registerForm.get('password')?.value as String,
        this.registerForm.get('rePassword')?.value as String,
      )
        .then(()=> { this.router.navigateByUrl('/auth/login') })
        .catch(()=> { alert('failed to register') });
        // TODO: better error messages
    else
      alert("failed to register");
  }
}
